/*
 * LiquidBounce Hacked Client
 * A free open source mixin-based injection hacked client for Minecraft using Minecraft Forge.
 * https://github.com/CCBlueX/LiquidBounce/
 */
package net.ccbluex.liquidbounce.features.module.modules.combat

import net.ccbluex.liquidbounce.event.*
import net.ccbluex.liquidbounce.features.module.Module
import net.ccbluex.liquidbounce.features.module.ModuleCategory
import net.ccbluex.liquidbounce.features.module.modules.movement.Speed
import net.ccbluex.liquidbounce.utils.MovementUtils.isOnGround
import net.ccbluex.liquidbounce.utils.MovementUtils.speed
import net.ccbluex.liquidbounce.utils.misc.RandomUtils.nextInt
import net.ccbluex.liquidbounce.utils.timing.MSTimer
import net.ccbluex.liquidbounce.value.BoolValue
import net.ccbluex.liquidbounce.value.FloatValue
import net.ccbluex.liquidbounce.value.IntegerValue
import net.ccbluex.liquidbounce.value.ListValue
import net.minecraft.network.play.server.S12PacketEntityVelocity
import net.minecraft.network.play.server.S27PacketExplosion
import kotlin.math.sqrt

object Velocity : Module("Velocity", ModuleCategory.COMBAT) {

    /**
     * OPTIONS
     */
    private val mode by ListValue(
        "Mode", arrayOf(
            "Simple", "AAC", "AACPush", "AACZero", "AACv4",
            "Reverse", "SmoothReverse", "Jumprest", "Glitch", "Legit","Legit+Jumprest"
        ), "Simple"
    )

    private val horizontal by FloatValue("Horizontal", 0F, 0F..1F) { mode in arrayOf("Simple", "AAC", "Legit") }
    private val vertical by FloatValue("Vertical", 0F, 0F..1F) { mode in arrayOf("Simple", "Legit") }

    // Reverse
    private val reverseStrength by FloatValue("ReverseStrength", 1F, 0.1F..1F) { mode == "Reverse" }
    private val reverse2Strength by FloatValue("SmoothReverseStrength", 0.05F, 0.02F..0.1F) { mode == "SmoothReverse" }
    private val reverseChance by IntegerValue("Chance", 100, 0..100) { mode == "Reverse" }

    // AAC Push
    private val aacPushXZReducer by FloatValue("AACPushXZReducer", 2F, 1F..3F) { mode == "AACPush" }
    private val aacPushYReducer by BoolValue("AACPushYReducer", true) { mode == "AACPush" }
    private val aacPushChance by IntegerValue("Chance", 100, 0..100) { mode == "AACPush" }

    // AAC v4
    private val aacv4MotionReducer by FloatValue("AACv4MotionReducer", 0.62F, 0F..1F) { mode == "AACv4" }
    private val aacv4 by IntegerValue("Chance", 100, 0..100) { mode == "AACV4" }

    // Legit
    private val legitDisableInAir by BoolValue("DisableInAir", true) { mode == "Legit" }
    private val legitChance by IntegerValue("Chance", 100, 0..100) { mode == "Legit" }

    // Jumprest
    private val jumpCooldownMode by ListValue("JumpCooldownMode", arrayOf("Ticks", "ReceivedHits"), "Ticks")
        { mode == "Jumprest" }
    private val ticksUntilJump by IntegerValue("TicksUntilJump", 4, 0..20)
        { jumpCooldownMode == "Ticks" && mode == "Jumprest" }
    private val hitsUntilJump by IntegerValue("ReceivedHitsUntilJump", 2, 0..5)
        { jumpCooldownMode == "ReceivedHits" && mode == "Jumprest" }
    private val jumprestChance by IntegerValue("Chance", 100, 0..100) { mode == "Jumprest" }

    // Legit+Jumprest
    private val legitDisableInAir by BoolValue("DisablenInAir",true) { mode == "Legit" }
    private val legitChance by IntegerValue("Chance", 100, 0..100) { mode == "Legit" }
    private val jumpCooldownMode by ListValue("JumpCooldownMode", arrayOf("Ticks", "ReceivedHits"), "Ticks")
        { mode == "Jumprest" }
    private val ticksUntilJump by IntegerValue("TicksUntilJump", 4, 0..20)
        { jumpCooldownMode == "Ticks" && mode == "Jumprest" }
    private val hitsUntilJump by IntegerValue("ReceivedHitsUntilJump", 2, 0..5)
        { jumpCooldownMode == "ReceivedHits" && mode == "Jumprest" }
    private val jumprestChance by IntegerValue("Chance", 100, 0..100) { mode == "Jumprest" }

    // TODO: Could this be useful in other modes? (Jump?)
    // Limits
    private val limitMaxMotionValue = BoolValue("LimitMaxMotion", false) { mode == "Simple" }
    private val maxXZMotion by FloatValue("MaxXZMotion", 0.4f, 0f..1.9f) { limitMaxMotionValue.isActive() }
    private val maxYMotion by FloatValue("MaxYMotion", 0.36f, 0f..0.46f) { limitMaxMotionValue.isActive() } //0.00075 is added silently

    // Vanilla XZ limits
    // Non-KB: 0.4 (no sprint), 0.9 (sprint)
    // KB 1: 0.9 (no sprint), 1.4 (sprint)
    // KB 2: 1.4 (no sprint), 1.9 (sprint)
    // Vanilla Y limits
    // 0.36075 (no sprint), 0.46075 (sprint)

    /**
     * VALUES
     */
    private var velocityTimer = MSTimer()
    private var hasReceivedVelocity = false

    // SmoothReverse
    private var reverseHurt = false

    // AACPush
    private var jump = false

    // Jumprest
    private var limitUntilJump = 0

    override val tag
        get() = mode

    override fun onDisable() {
        mc.thePlayer?.speedInAir = 0.02F
    }

    @EventTarget
    fun onUpdate(event: UpdateEvent) {
        val thePlayer = mc.thePlayer ?: return

        if (thePlayer.isInWater || thePlayer.isInLava || thePlayer.isInWeb)
            return

        when (mode.lowercase()) {
            "glitch" -> {
                thePlayer.noClip = hasReceivedVelocity

                if (thePlayer.hurtTime == 7)
                    thePlayer.motionY = 0.4

                hasReceivedVelocity = false
            }

            "reverse" -> {
                if (!hasReceivedVelocity)
                    return

                if (!thePlayer.onGround) {
                    speed *= reverseStrength
                } else if (velocityTimer.hasTimePassed(80))
                    hasReceivedVelocity = false
            }

            "smoothreverse" -> {
                if (!hasReceivedVelocity) {
                    thePlayer.speedInAir = 0.02F
                    return
                }

                if (thePlayer.hurtTime > 0)
                    reverseHurt = true

                if (!thePlayer.onGround) {
                    if (reverseHurt)
                        thePlayer.speedInAir = reverse2Strength
                } else if (velocityTimer.hasTimePassed(80)) {
                    hasReceivedVelocity = false
                    reverseHurt = false
                }
            }

            "aac" -> if (hasReceivedVelocity && velocityTimer.hasTimePassed(80)) {
                thePlayer.motionX *= horizontal
                thePlayer.motionZ *= horizontal
                //mc.thePlayer.motionY *= vertical ?
                hasReceivedVelocity = false
            }

            "aacv4" ->
                if (thePlayer.hurtTime > 0 && !thePlayer.onGround) {
                    val reduce = aacv4MotionReducer
                    thePlayer.motionX *= reduce
                    thePlayer.motionZ *= reduce
                }

            "aacpush" -> {
                if (jump) {
                    if (thePlayer.onGround)
                        jump = false
                } else {
                    // Strafe
                    if (thePlayer.hurtTime > 0 && thePlayer.motionX != 0.0 && thePlayer.motionZ != 0.0)
                        thePlayer.onGround = true

                    // Reduce Y
                    if (thePlayer.hurtResistantTime > 0 && aacPushYReducer && !Speed.state)
                        thePlayer.motionY -= 0.014999993
                }

                // Reduce XZ
                if (thePlayer.hurtResistantTime >= 19) {
                    val reduce = aacPushXZReducer

                    thePlayer.motionX /= reduce
                    thePlayer.motionZ /= reduce
                }
            }

            "aaczero" ->
                if (thePlayer.hurtTime > 0) {
                    if (!hasReceivedVelocity || thePlayer.onGround || thePlayer.fallDistance > 2F)
                        return

                    thePlayer.motionY -= 1.0
                    thePlayer.isAirBorne = true
                    thePlayer.onGround = true
                } else
                    hasReceivedVelocity = false

            "legit" -> {
                if (legitDisableInAir && !isOnGround(0.5))
                    return

                if (mc.thePlayer.maxHurtResistantTime != mc.thePlayer.hurtResistantTime || mc.thePlayer.maxHurtResistantTime == 0)
                    return

                if (nextInt(endExclusive = 100) < legitChance) {
                    val horizontal = horizontal / 100f
                    val vertical = vertical / 100f

                    thePlayer.motionX *= horizontal.toDouble()
                    thePlayer.motionZ *= horizontal.toDouble()
                    thePlayer.motionY *= vertical.toDouble()
                }
            }
        }
    }

    @EventTarget
    fun onPacket(event: PacketEvent) {
        val thePlayer = mc.thePlayer ?: return

        val packet = event.packet

        if (
            (
                packet is S12PacketEntityVelocity
                    && thePlayer.entityId == packet.entityID
                    && packet.motionY > 0
                    && (packet.motionX != 0 || packet.motionZ != 0)
            ) || (
                packet is S27PacketExplosion
                    && packet.field_149153_g > 0f
                    && (packet.field_149152_f != 0f || packet.field_149159_h != 0f)
            )
        ) {
            velocityTimer.reset()

            when (mode.lowercase()) {
                "simple" -> handleVelocity(event)

                "aac", "reverse", "smoothreverse", "aaczero", "jump" -> hasReceivedVelocity = true

                "glitch" -> {
                    if (!thePlayer.onGround)
                        return

                    hasReceivedVelocity = true
                    event.cancelEvent()
                }
            }
        }
    }

    @EventTarget
    fun onJump(event: JumpEvent) {
        val thePlayer = mc.thePlayer

        if (thePlayer == null || thePlayer.isInWater || thePlayer.isInLava || thePlayer.isInWeb)
            return

        when (mode.lowercase()) {
            "aacpush" -> {
                jumprest = true

                if (!thePlayer.isCollidedVertically)
                    event.cancelEvent()
            }

            "aaczero" ->
                if (thePlayer.hurtTime > 0)
                    event.cancelEvent()
        }
    }

    @EventTarget
    fun onStrafe(event: StrafeEvent) {
        val player = mc.thePlayer ?: return

        if (mode == "Jumprest" && player.onGround && player.hurtTime == 9 && shouldJump() && hasReceivedVelocity) {
            player.jump()
            limitUntilJump = 0
            hasReceivedVelocity = false
            return
        }

        when (jumpCooldownMode.lowercase()) {
            "ticks" -> limitUntilJump++
            "receivedhits" -> if (player.hurtTime == 9) limitUntilJump++
        }
    }

    private fun shouldJump() = when (jumpCooldownMode.lowercase()) {
        "ticks" -> limitUntilJump >= ticksUntilJump
        "receivedhits" -> limitUntilJump >= hitsUntilJump
        else -> false
    }

    private fun handleVelocity(event: PacketEvent) {
        val packet = event.packet

        if (horizontal + vertical == 0f)
            return event.cancelEvent()

        if (packet is S12PacketEntityVelocity) {
            packet.motionX = (packet.motionX * horizontal).toInt()
            packet.motionY = (packet.motionY * vertical).toInt()
            packet.motionZ = (packet.motionZ * horizontal).toInt()

            if (limitMaxMotionValue.get()) {
                val distXZ = sqrt((packet.motionX * packet.motionX + packet.motionZ * packet.motionZ).toDouble()) / 8000.0
                val distY = packet.motionY / 8000.0
                val maxYMotion = maxYMotion + 0.00075

                if (distXZ > maxXZMotion) {
                    val ratioXZ = maxXZMotion / distXZ

                    packet.motionX = (packet.motionX * ratioXZ).toInt()
                    packet.motionZ = (packet.motionZ * ratioXZ).toInt()
                }

                if (distY > maxYMotion) {
                    packet.motionY = (packet.motionY * maxYMotion / distY).toInt()
                }
            }
        } else if (packet is S27PacketExplosion) {
            packet.field_149152_f *= horizontal // motionX
            packet.field_149153_g *= vertical // motionY
            packet.field_149159_h *= horizontal // motionZ

            if (limitMaxMotionValue.get()) {
                val distXZ = sqrt(packet.field_149152_f * packet.field_149152_f + packet.field_149159_h * packet.field_149159_h)
                val distY = packet.field_149153_g
                val maxYMotion = maxYMotion + 0.00075f

                if (distXZ > maxXZMotion) {
                    val ratioXZ = maxXZMotion / distXZ

                    packet.field_149152_f *= ratioXZ
                    packet.field_149159_h *= ratioXZ
                }

                if (distY > maxYMotion) {
                    packet.field_149153_g *= maxYMotion / distY
                }
            }
        }
    }
}
